/* File:		test.cpp
 * Author(s):	Michael Deardeuff	<mr__goodbytes@hotmail.com
 * Description:
 *		Tests the CallFunctionByName Routine
 * Notes:
 *		Copyright (C) 2000 Michael Deardeuff
 *		You may use this code in anything you want as long as you keep the copyright notices intact
 */

#ifdef _MSC_VER // >= 1200					// For MSVC++ Only (6.0+ in comments)
#pragma warning(disable :4786)				// Disable all those pesky warnings you get
#endif // _MSC_VER							// from using the STL

#include <map>

#include "mgTable.h"
#include "function.h"
/*
extern "C"
{
StringTable functionTable;
std::map<char *, FunctionPointer> mFunction;
}
*/
void FunctionTableInit();

int main()
{
	FunctionTableInit();

	bool done=false;
	char buf[32];
	do
	{
		printf("Enter name of function in function table\n");
		printf("Or enter 'bye', 'quit', or 'end' to exit:\n");
		printf("Currently only HoserChild and MrGoodbytes\n");
		printf("are valid function names\n\nFunction: ");
		
		// Get Function name
		if( fgets( buf, sizeof( buf ), stdin ) == NULL )
		{
			done = true;
			break;
		}
				
		// remove the trailing '\n' from string
		strchr(buf, 10)[0] = '\0';	// isn't that ugly :C
		
		String command = buf;
		
		// see if user wants to quit
		if ( command == "bye" || command == "end" || command == "quit" )
		{
			done = true;
			break;
		}
		else
		{
			// enter "arguments"
			printf("\nEnter a string to pass as an argument\nArgs: ");

			command = buf;
			if( fgets( buf, sizeof( buf ), stdin ) == NULL )
			{
				done = true;
				break;
			}
			
			printf("\n\n-------------------------------------------\n\n");
			if (!CallFunctionByName((char *)command.c_str(), buf))
				printf("\n%s is not in the Callable Function Table\n\n", command.c_str());
		}
		
	} while ( !done );

	printf("\n\n---------------------------------\n\n");
	// Can also be called with a string literal:
	CallFunctionByName( "MrGoodbytes", (void *)"Goodbye");

	return 0;
}

// Add the functions to the list
void FunctionTableInit()
{
	AddFunction("HoserChild", HoserChild);
	AddFunction("MrGoodbytes", MrGoodbytes);
	AddFunction("NullFunc", NULL);
};

/**** The User Callable Functions ********************************************/
void HoserChild(void *args)
{
	printf("HoserChild says:\n%s\n", (char *)args);
}

void MrGoodbytes(void *args)
{
	printf("Mr Goodbytes' own personal function:\n%s\n", (char *)args);	
}